Subject: Re: [Dime] Suresh Krishnan's Discuss on draft-ietf-dime-rfc4006bis-08: (with DISCUSS and COMMENT)

From: Ben Campbell <[email-masked]>
Date: Mon, 13 Aug 2018 16:10:56 -0500

Hi,

I don’t think Suresh’s DISCUSS has been resolved in revision 10.Please see inline:

Thanks!

Ben.

> On May 23, 2018, at 9:03 PM, Dave Dolson <[email-masked]> wrote:
> 
> Suresh,
> 
> Please see inline.
> 
> 
> On 2018-05-23 04:55 PM, Suresh Krishnan wrote:
>> Suresh Krishnan has entered the following ballot position for
>> draft-ietf-dime-rfc4006bis-08: Discuss
>> 
>> 
>> 
>> Please refer to https://www.ietf.org/iesg/statement/discuss-criteria.html
>> for more information about IESG DISCUSS and COMMENT positions.
>> 
>> 
>> The document, along with other ballot positions, can be found here:
>> https://datatracker.ietf.org/doc/draft-ietf-dime-rfc4006bis/
>> 
>> 
>> 
>> ----------------------------------------------------------------------
>> DISCUSS:
>> ----------------------------------------------------------------------
>> 
>> Section 8.38.
>> 
>> RFC5952 contains significant changes in text representation from RFC3513 and I
>> am concerned that there might be RFC4006 compliant implementations that will no
>> longer be legal with a MUST level use of RFC5952. e.g. Addresses with upper
>> case hex digits, with leading zeroes in 16 bit fields etc. Has the working
>> group considered this break in compatibility already in its discussions?
>> 
>> If it has, this text should still be finessed a bit because RFC5952
>> recommendations (even at the MUST level) are a SHOULD for senders with the
>> receivers being required to handle all possible legal formats as per RFC4291.
>> So at least the sender rules and receiver rules need to be written differently.
> If I recall correctly, we did give this some thought. RFC 5952 was presumably done for a reason, due to flaws in previous descriptions of address format. Hence it is prudent to use the new requirements. Implementations are free to be liberal in what they receive, for backwards compatibility with RFC 4006.
> So I think it's fair to say this standard requires use of RFC 5952 syntax.

I cannot find evidence of discussion on the DIME list about backwards compatibility related to the RFC 5952 encoding.

Authors/Shepherd: Are you aware of something I missed? Maybe this was discussed in a meeting? Does anyone know whether existing implementations are typically compatible with 5952? (I guess this is most commonly used in 3GPP networks; does anyone know if the relevant 3GPP specs have anything to say bout 5952 vs 3513 encoding?)

In any case, this doesn’t respond to Suresh’s second paragraph, and I don’t find changes in version 10 related to it.

I think that to clear Suresh’s DISCUSS, the draft needs to at least include a short discussion of the potential for backwards compatibility issues, and to clarify the normative language around as described in his second paragraph.

Suresh: Do you agree?

> 
>> 
>> 
>> ----------------------------------------------------------------------
>> COMMENT:
>> ----------------------------------------------------------------------
>> 
>> Section 8.65
>> 
>> Any reason you are allowing encoding an IPv4 address as a IPv4-Mapped IPv6
>> Address while you can directly use address family 1 to encode it directly as an
>> IPv4 address? This allows for two different encodings for the same address.
> Because IPv4-mapped IPv6 is a good idea. It allows coders to ignore IPv4 and just develop for IPv6.
> If we hadn't mentioned it explicitly, I think some people would have assumed it to be supported and others not.
> So we had the choice of allowing it or prohibiting it. We chose to allow.
> 
> 
> -Dave
>

---

From: Suresh Krishnan <[email-masked]>
Date: Wed, 15 Aug 2018 11:44:48 -0400

Hi Ben,

> On Aug 13, 2018, at 5:10 PM, Ben Campbell <[email-masked] <mailto:[email-masked]>> wrote:
> 
> Hi,
> 
>> On May 23, 2018, at 9:03 PM, Dave Dolson <[email-masked] <mailto:[email-masked]>> wrote:
>> 
>> Suresh,
>> 
>> Please see inline.
>> 
>> 
>>> Please refer to https://www.ietf.org/iesg/statement/discuss-criteria.html <https://www.ietf.org/iesg/statement/discuss-criteria.html>
>>> https://datatracker.ietf.org/doc/draft-ietf-dime-rfc4006bis/ <https://datatracker.ietf.org/doc/draft-ietf-dime-rfc4006bis/>
>>> 
>>> 
>>> 

Yes. I agree. I am fine even if the text simply says some legacy implementations may no longer be compliant because of this change.

Thanks
Suresh

---

From: Dave Dolson <[email-masked]>
Date: Tue, 21 Aug 2018 23:01:33 -0230

Would a backwards compatibility statement go in section 8.38 itself, or 
in the appendix C (Changes relative to RFC4006)?

I suggest that in section 8.38, the following paragraph be added:

"Because RFC5952 is more restrictive than the RFC3513 format required by 
RFC4006, implementations receiving this AVP MAY be liberal in the 
textual IPv6 representations that are accepted without raising an error."

Comments?

-Dave

On 2018-08-15 1:14 PM, Suresh Krishnan wrote:
>>>> Please refer to 
>>>> https://www.ietf.org/iesg/statement/discuss-criteria.html
>>> If I recall correctly, we did give this some thought. RFC 5952 was 
>>> presumably done for a reason, due to flaws in previous descriptions 
>>> of address format. Hence it is prudent to use the new requirements. 
>>> Implementations are free to be liberal in what they receive, for 
>>> backwards compatibility with RFC 4006.
>> I cannot find evidence of discussion on the DIME list about backwards 
>> compatibility related to the RFC 5952 encoding.
>>
>> Authors/Shepherd: Are you aware of something I missed? Maybe this was 
>> discussed in a meeting? Does anyone know whether existing 
>> implementations are typically compatible with 5952? (I guess this is 
>> most commonly used in 3GPP networks; does anyone know if the relevant 
>> 3GPP specs have anything to say bout 5952 vs 3513 encoding?)
>>
>> In any case, this doesn’t respond to Suresh’s second paragraph, and I 
>> don’t find changes in version 10 related to it.
>>
>> I think that to clear Suresh’s DISCUSS, the draft needs to at least 
>> include a short discussion of the potential for backwards 
>> compatibility issues, and to clarify the normative language around as 
>> described in his second paragraph.
>>
>> Suresh: Do you agree?
>
> Yes. I agree. I am fine even if the text simply says some legacy 
> implementations may no longer be compliant because of this change.
>
> Thanks
> Suresh
>

---

From: Ben Campbell <[email-masked]>
Date: Wed, 22 Aug 2018 17:17:49 -0500

Hi,

I agree this should go in 8.38, not in the appendix.

Would something to the effect of the following make sense?

"Because RFC5952 is more restrictive than the RFC3513 format required by RFC4006, some legacy implementations may not be compliant with the new requirements. Accordingly, implementations receiving this AVP MAY be liberal in the textual IPv6 representations that are accepted without raising an error.”

Thanks!

Ben.

> On Aug 21, 2018, at 8:31 PM, Dave Dolson <[email-masked]> wrote:
> 
> Would a backwards compatibility statement go in section 8.38 itself, or in the appendix C (Changes relative to RFC4006)?
> 
> "Because RFC5952 is more restrictive than the RFC3513 format required by RFC4006, implementations receiving this AVP MAY be liberal in the textual IPv6 representations that are accepted without raising an error."
> 
> Comments?
> -Dave
> 
>>> On Aug 13, 2018, at 5:10 PM, Ben Campbell <[email-masked]> wrote:
>>> 
>>> Hi,
>>>

---

From: Dave Dolson <[email-masked]>
Date: Wed, 22 Aug 2018 22:08:24 -0230

Sure, that's even more explicit. Any objections?

On 2018-08-22 7:47 PM, Ben Campbell wrote:
> _______________________________________________
> DiME mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/dime

---

From: Suresh Krishnan <[email-masked]>
Date: Thu, 23 Aug 2018 16:38:21 -0400

Hi Dave/Ben,
  This new text suggestion fully addresses my DISCUSS. I will clear as
soon as the new version hits (or if Ben can add an RFC editor note, I
will clear right away).

Regards
Suresh

---

From: Ben Campbell <[email-masked]>
Date: Thu, 23 Aug 2018 15:42:42 -0500

If I understand correctly, there needs to be at least one more version for unrelated reasons. Therefore I prefer that the authors add the text to the update.

Thanks!

Ben.

> On Aug 23, 2018, at 3:38 PM, Suresh Krishnan <[email-masked]> wrote:
> 
> Hi Dave/Ben,